#version 430 core

// Interpolated values from the vertex shaders
in vec2 UV;
in vec3 Position_worldspace;
in vec3 Normal_cameraspace;
in vec3 EyeDirection_cameraspace;
in vec3 LightDirection_cameraspace[1];

// Ouput data
out vec4 color;

// Values that stay constant for the whole mesh.
uniform sampler2D myTextureSampler;
uniform mat4 MV;
uniform vec3 LightPosition_worldspace[1];

void main()
{
    color = vec4(0.0, 0.0, 0.0, 1.0);

    // illuminence loop test
    for(int i=0; i<1; i++)
    {
	    vec3 LightColor = vec3(0.8, 1.0, 1.0);

        //LightColor = 0.1 * (noise3(362584 * i) + 1) * 0.5;
        //LightColor[0] = 1 * (noise1(25284 * i) + 1) * 0.5;
        //LightColor[2] = 0.1 * (noise1(654 * i) + 1) * 0.5;
        
        float LightPower = 2.0f;
	
	    vec3 MaterialDiffuseColor = 30 * texture2D( myTextureSampler, UV ).rgb;
	    vec3 MaterialAmbientColor = vec3(1.0, 1.0, 1.0) * MaterialDiffuseColor;
	    vec3 MaterialSpecularColor = vec3(0.5, 0.5, 0.5);

	    float distance = length( LightPosition_worldspace[i] - Position_worldspace );

	    vec3 n = normalize( Normal_cameraspace );
	    vec3 l = normalize( LightDirection_cameraspace[i] );
	    float cosTheta = clamp( dot( n,l ), 0,1 );
	
	    vec3 E = normalize(EyeDirection_cameraspace);
	    vec3 R = reflect(-l,n);
	    float cosAlpha = clamp( dot( E,R ), 0,1 );
	
	    vec3 cd = 
		    MaterialDiffuseColor * LightColor * LightPower * cosTheta / (distance*distance) +
		    MaterialSpecularColor * LightColor * LightPower * pow(cosAlpha,5) / (distance*distance);

        color += vec4(cd.xyz, 1.0);
        //color = vec4(cd.xyz, cd.x);
        //color = vec4(vec3(pow(gl_FragCoord.z, 6)), 1.0);
        //color = vec4(cd.xyz, cd.x * mod(gl_FragCoord.y, 3));
        //color = vec4(cd.xyz, cd.x * mod(gl_FragCoord.y, 3));
    }
}
